#include <msp/fs/dir.h>
#include <msp/fs/stat.h>
#include "directorycollection.h"

using namespace std;

namespace Msp {
namespace DataFile {

DirectoryCollection::DirectoryCollection()
{
	set_directory(".");
}

void DirectoryCollection::set_directory(const FS::Path &d)
{
	dirs.clear();
	add_directory(d);
}

void DirectoryCollection::add_directory(const FS::Path &d)
{
	dirs.push_back(d);
}

void DirectoryCollection::load_names()
{
	for(list<FS::Path>::const_iterator i=dirs.begin(); i!=dirs.end(); ++i)
	{
		list<string> names = FS::list_files(*i);
		for(list<string>::const_iterator j=names.begin(); j!=names.end(); ++j)
			add_future(*j);
	}
}

bool DirectoryCollection::lookup_file(const string &name, FS::Path &result) const
{
	for(list<FS::Path>::const_iterator i=dirs.begin(); i!=dirs.end(); ++i)
	{
		FS::Path file_path = *i/name;
		if(FS::exists(file_path))
		{
			result = file_path;
			return true;
		}
	}

	return false;
}

} // namespace DataFile
} // namespace Msp
